"use strict";

{
  const SDK = self.SDK;
  const PLUGIN_ID = "Null";
  const PLUGIN_VERSION = "1.0.0";
  const PLUGIN_CATEGORY = "general";

  class NullPlugin extends SDK.IPluginBase {
    constructor() {
      super(PLUGIN_ID);

      SDK.Lang.PushContext("plugins." + PLUGIN_ID.toLowerCase());

      this._info.SetName(self.lang(".name"));
      this._info.SetDescription(self.lang(".description"));
      this._info.SetVersion(PLUGIN_VERSION);
      this._info.SetCategory(PLUGIN_CATEGORY);
      this._info.SetAuthor("Dave Caruso");
      this._info.SetHelpUrl(self.lang(".help-url"));
      this._info.SetPluginType("world");
      this._info.SetIsResizable(true);
      this._info.SetIsRotatable(true);
      this._info.SetHasImage(false);
      this._info.SetSupportsEffects(false);
      this._info.SetMustPreDraw(false);

      SDK.Lang.PushContext(".properties");
      this._info.SetProperties([]);
      SDK.Lang.PopContext();

      SDK.Lang.PopContext();
    }
  }

  SDK.Plugins.Null = NullPlugin;

  NullPlugin.Register(PLUGIN_ID, NullPlugin);

  NullPlugin.Type = class NullPluginType extends SDK.ITypeBase {
    constructor(sdkPlugin, iObjectType) {
      super(sdkPlugin, iObjectType);
    }
  };

  NullPlugin.Instance = class NullPluginInstance extends SDK.IWorldInstanceBase {
    constructor(sdkType, inst) {
      super(sdkType, inst);
    }

    Release() {}

    OnCreate() {}

    OnPlacedInLayout() {}

    Draw(iRenderer, iDrawParams) {
      iRenderer.SetAlphaBlend();
      console.log(iRenderer);
      iRenderer.SetColorFillMode();
      iRenderer.SetColorRgba(0, 0, 0.1, 0.1);
      iRenderer.Quad(this._inst.GetQuad());
    }

    GetTexture() {}

    IsOriginalSizeKnown() {
      return true;
    }

    GetOriginalWidth() {
      return 1;
    }

    GetOriginalHeight() {
      return 1;
    }

    HasDoubleTapHandler() {
      return false;
    }

    OnPropertyChanged(id, value) {}

    LoadC2Property(name, valueString) {
      return false;
    }
  };
}
